#ifndef DISPLAYMAP_H
#define DISPLAYMAP_H

#include "matrix.h"

  /* Displaymap constants. */

#define MAXROOTOBJECTS 100

#define CUROBJECT      0	/* Specify a connection on the same level. */
#define SUBOBJECT      1	/* Subobject connection. */
#define NONE           0	/* No matrix is specified for this block. */
#define SET            1	/* Set the local matrix to the one specified. */
#define APPEND         2	/* Append the specified matrix to the local one. */
 
  /* Displaymap structures. */
  
struct Action {
   UBYTE transtype,changed;
   MATRIX lm;
   MATRIX cmtm;
   MATRIX transmatrix;
   ULONG model,object;
   struct Action *previous,*subobject,*next;
};      

void cleardisplaymap(void);
struct Action *createrootaction(MATRIX,ULONG);
struct Action *createaction(struct Action *,MATRIX,UBYTE,ULONG,UBYTE);
void removeroot(struct Action *);
void removeaction(struct Action *);
void traversedisplaymap(void);

#endif
